{
  fpcX v.0.1.3

  (C)2K4 by CARSTEN WAECHTER aka THE TOXIC AVENGER/AINC.

  This DLL is Public Domain..
   Feel free to use, enhance or even learn about this code..
  If you like it, please drop a message to:
   toxie@ainc.de
  To get the newest version of fpcX surf to:
   http://ainc.de

  All changes are listed below..
}

{$D-,L-}

Library FPCX;

Uses windows,ddraw,dxtools;          //I've taken the DirectX5-Files by Eric Unger - Just compile everything using the DCC32-Command-Prompt-Compiler delivered with Delphi


Var DDSurface : IDirectDrawSurface;  //The Surface we draw on
    DDObject2 : IDirectDraw2;        //The Object to use DirectDraw2-Functions
    XRes,YRes : longint;             //Our Fullscreen-Resolution (init by GetDefaultDirectDraw)
    BPP       : longint;             //16,32 (24??!!)

PROCEDURE GetDefaultDirectDraw(ParentWindow : hWND; x,y,bits : longint);stdcall;export;
 Var SurfDesc : TDDSurfaceDesc;
     DDObject : IDirectDraw;
BEGIN
  xres:=x;
  yres:=y;

  bpp:=bits;

  DDObject :=nil;
  DDObject2:=nil;

  DDCheck(DirectDrawCreate(nil,DDObject,nil));                  //Create DirectDraw-Object using the Default-Video-Card
  DDCheck(DDObject.QueryInterface(IID_IDirectDraw2,DDObject2)); //Get DirectDraw2-Object
  DDObject:=nil;                                                //Not used anymore
  DDCheck(DDObject2.SetCooperativeLevel(ParentWindow, DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN or DDSCL_ALLOWREBOOT)); //Get FullScreen/Exclusive
  DDCheck(DDObject2.SetDisplayMode(xres, yres, bpp, 0, 0));     //Set Mode XRESxYRES/65536/32768(HiColor)=16, 16777216(TrueColor)=32 (24??!!)

  fillchar(SurfDesc,sizeof(SurfDesc),0);                        //Fill Data-Structure to get DoubleBuffering
  SurfDesc.dwSize            := sizeof(SurfDesc);
  SurfDesc.dwFlags           := DDSD_CAPS or DDSD_BACKBUFFERCOUNT;
  SurfDesc.dwBackBufferCount := 1;
  SurfDesc.ddsCaps.dwCaps    := DDSCAPS_PRIMARYSURFACE or DDSCAPS_FLIP or DDSCAPS_COMPLEX;

  DDCheck(DDObject2.CreateSurface(SurfDesc, DDSurface, nil));   //Get Surface using Data-Structure
END;


PROCEDURE CloseDirectDraw;stdcall;export;
BEGIN
  DDSurface:=nil;                                 //Not used anymore

  DDObject2.RestoreDisplayMode;                   //Restore old GFX-Mode
  DDObject2.SetCooperativeLevel(0, DDSCL_NORMAL); //Restore CoopLevel to normal
  DDObject2:=nil;                                 //Throw it away
END;


FUNCTION DirectDrawBlit(buf : pointer) : boolean;stdcall;export;
 Var Caps : TDDSCaps;
     dds  : IDirectDrawSurface;
     SurfaceDescription : TDDSurfaceDesc;
     BitMask : cardinal;
     y : longint;
     source,dest : pointer;
BEGIN
  if (ddSurface.IsLost<>DD_OK) then               //Check if we still got our Surface active (and try to restore it)
   if (ddSurface.Restore<>DD_OK) then begin result:=false; exit; end;

  fillchar(caps, sizeof(caps), 0);                //Fill Data-Structure to get BackBuffer-Surface
  caps.dwCaps := DDSCAPS_BACKBUFFER;
  if (DDSurface.GetAttachedSurface(caps,dds)<>DD_OK) then begin result:=false; exit; end;

  if (dds.IsLost<>DD_OK) then                     //Check if that one's still active (and try to restore it)
   if (dds.Restore<>DD_OK) then begin result:=false; exit; end;

  fillchar(SurfaceDescription, sizeof(SurfaceDescription), 0); //Get Ptr to access VideoMemory directly
  SurfaceDescription.dwSize:=sizeof(SurfaceDescription);
  if (dds.Lock(nil, SurfaceDescription, DDLOCK_SURFACEMEMORYPTR or DDLOCK_WAIT, 0)<>DD_OK) then begin result:=false; exit; end;


  //Here comes that f##kin copying of our buffer to the screen
  //It's quiet long, cause we should support GFX-Cards with 15Bit-Drivers only (like my S3 =)

  BitMask:=SurfaceDescription.ddpfPixelFormat.dwRBitMask or SurfaceDescription.ddpfPixelFormat.dwGBitMask or SurfaceDescription.ddpfPixelFormat.dwBBitMask; //Used for check if 16Bit/15Bit

  //! 24bits ??!!
  if (bpp=32) then begin
   if (SurfaceDescription.lPitch=xres*4) then                  //Our "internal" resolution = The "real" resolution
    move(buf^,SurfaceDescription.lpSurface^,xres*yres*4)
   else begin                                                  //If not then copy every single line
    source:=buf;
    dest:=SurfaceDescription.lpSurface;
    for y:=0 to yres-1 do begin
     move(source^,dest^,xres*4);
     dest:=pointer(cardinal(dest)+SurfaceDescription.lPitch);
     source:=pointer(cardinal(source)+xres*4);
    end;
   end;
  end else
  if (BitMask=$0000ffff) then                                  //It's really 16Bit
   if (SurfaceDescription.lPitch=xres*2) then                  //Our "internal" resolution = The "real" resolution
    move(buf^,SurfaceDescription.lpSurface^,xres*yres*2)
   else begin                                                  //If not then copy every single line
    source:=buf;
    dest:=SurfaceDescription.lpSurface;
    for y:=0 to yres-1 do begin
     move(source^,dest^,xres*2);
     dest:=pointer(cardinal(dest)+SurfaceDescription.lPitch);
     source:=pointer(cardinal(source)+xres*2);
    end;
   end else //It's 15Bit (yeah, confusing, huh ?? direct draw says that it's 16Bit, although it could be 15Bit :(
  begin
   source:=buf;
   dest:=SurfaceDescription.lpSurface;
   for y:=0 to yres-1 do begin
    ASM
     pushad
     mov   esi, source
     mov   edi, dest
     mov   ecx, xres
     shr   ecx, 2
     lea   esi, [esi + ecx*8]
     lea   edi, [edi + ecx*8]
     not   ecx
   @@Next4Pixels:
     mov   eax, [ecx*8+esi]
     mov   edx, [ecx*8+esi+4]
     mov   ebx, eax
     mov   ebp, edx
     shr   ebx, 1
     and   eax, $0001f001f
     shr   ebp, 1
     and   edx, $0001f001f
     and   ebx, $0ffe0ffe0
     and   ebp, $0ffe0ffe0
     or    ebx, eax
     or    edx, ebp
     mov   [ecx*8+edi],   ebx
     mov   [ecx*8+edi+4], edx
     inc   ecx
     jnz   @@Next4Pixels
     popad
    END;   //Taken from PC-Underground (published in PC-Magazin) by Nils Pipenbrinck
    dest:=pointer(cardinal(dest)+SurfaceDescription.lPitch);
    source:=pointer(cardinal(source)+xres*2);
   end;
  end;

  //O.K. Done that..


  if (dds.Unlock(SurfaceDescription.lpSurface)<>DD_OK) then begin result:=false; exit; end; //Unlock the Ptr

  if (DDSurface.Flip(nil, DDFLIP_WAIT)<>DD_OK) then begin result:=false; exit; end; //Flip BackBuffer

  Result:=TRUE;
END;


Exports
 GetDefaultDirectDraw,
 CloseDirectDraw,
 DirectDrawBlit;


END.

{
  History:

  v.0.1.0: First Public Release..

  v.0.1.1: Fixed output on 15Bit-Cards and others..
           Fixed fpc-pointer-error by using stdcall's..

  v.0.1.2: Variable resolutions..

  v.0.1.3: 32Bit resolutions.. (24bits?!)
}